#include <windows.h>
#include <winuser.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windowsx.h>
#include <commctrl.h>
#include <string.h>

const char g_szClassName[] = "myWindowClass";
HDC hdc;
HDC hdcMem;
HWND hwnd;
int nVirtKey,CurrentTimer,LastGameCycle,serial_port,graph_xpos,speeddec,graph_ypos;
unsigned metres,rower,pace;
HANDLE hComm = NULL;
COMMTIMEOUTS ctmoNew = {0}, ctmoOld;
DCB dcbCommPort;
char InBuff[100];
unsigned long int dwBytesRead;
char status,ask;
char tempfloatarray[4];
char wintext[13] = "             ";
char wintextb[13] = "             ";
float actualdistance, olddistance, speed, oldspeed, actualpace, oldpace;

PAINTSTRUCT ps;
RECT rcClient;
TCHAR chCharCode;
MSG Msg;
BOOL Active;
char text[] = "PM2FC-w32\n\nby Josh Wedlake, Jonney Stone,\nAlex Bouraoui, theForger,\nGandalf, oh yeah and Sean.\n\nDistributed by illuminate.no-ip.com\n(c)2004 under GNU";

void getdistance(void);
void AppQuit(void);
void opencomporta(void);
void closecomporta(void);
void getpace(void);

// Step 4: the Window Procedure
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch(msg)
    {
		case WM_ACTIVATEAPP://Lets go
			Active = wParam;
		break;
		case WM_CREATE:
		break;
        case WM_CLOSE:
			closecomporta();
            DestroyWindow(hwnd);
        break;
        case WM_DESTROY:
			DeleteDC(hdcMem);
        	EndPaint(hwnd, &ps);
            PostQuitMessage(0);
        break;
		case WM_PAINT:
    		{
        	hdc = BeginPaint(hwnd, &ps);
			hdcMem = CreateCompatibleDC(hdc);
			}
		break;
		case WM_CHAR:
			{
			chCharCode = (TCHAR) wParam;    // character code
			}
		break;
        default:
            return DefWindowProc(hwnd, msg, wParam, lParam);
		}
	    return 0;
}

void getdistance(void)
{
	float *ergdistance;
	TransmitCommChar(hComm, metres);       //transmit distance query
	TransmitCommChar(hComm, rower);        	// erg address -always zero

	ReadFile(hComm, InBuff, 5, &dwBytesRead, NULL);
									  //read the serial port
	if(dwBytesRead)
	{
		status = InBuff[0];
		tempfloatarray[0] = InBuff[1];
		tempfloatarray[1] = InBuff[2];
		tempfloatarray[2] = InBuff[3];
		tempfloatarray[3] = InBuff[4];
		ergdistance = (float*)&tempfloatarray;
		actualdistance=*ergdistance;
		// s = d/t
		// a (d/t - d/t)/t
		// use speed?
		// speed = (actualdistance-olddistance)/(0.1) ok?
		//if((actualdistance-olddistance)!=0)
		oldspeed=speed;
		speed = (actualdistance-olddistance)/(0.2);
		//curve smoothing
		speed=(speed+oldspeed)/2;
		// another problem:
		// speed is a float.  we need a decimal for drawing. multiply by what?
		graph_xpos=graph_xpos+10;
		// debugging line below - delete for final compile
		printf("\nImmediate Speed: %f",speed);
		printf("\nGraph X Pos    : %d",graph_xpos);
		olddistance=actualdistance;
	}
	else
	{
		//debugging line below:
		printf("\nErg not currently active! Check Cables!");
	}
}

void getpace(void)
{
	float *ergpace;
	TransmitCommChar(hComm, pace);       //transmit distance query
	TransmitCommChar(hComm, rower);        	// erg address -always zero

	ReadFile(hComm, InBuff, 5, &dwBytesRead, NULL);
									  //read the serial port
	if(dwBytesRead)
	{
		oldpace=actualpace;
		status = InBuff[0];
		tempfloatarray[0] = InBuff[1];
		tempfloatarray[1] = InBuff[2];
		tempfloatarray[2] = InBuff[3];
		tempfloatarray[3] = InBuff[4];
		ergpace = (float*)&tempfloatarray;
		actualpace=*ergpace;
		if(actualpace!=oldpace)
			{
			//signal the start of a new stroke
			LineTo(hdc,graph_xpos,0);
			LineTo(hdc,graph_xpos,600);
			LineTo(hdc,graph_xpos,graph_ypos);
			}
	}
}

void AppQuit(void)
{
	printf("Error...\n");
}

void opencomporta(void)
{

// OPEN THE COMM PORT.
	if (serial_port==1)
	hComm = CreateFile("COM1", GENERIC_READ | GENERIC_WRITE, 0, 0,
										OPEN_EXISTING, 0, 0);
	if (serial_port==2)
	hComm = CreateFile("COM2", GENERIC_READ | GENERIC_WRITE, 0, 0,
										OPEN_EXISTING, 0, 0);
	if (serial_port==3)
	hComm = CreateFile("COM3", GENERIC_READ | GENERIC_WRITE, 0, 0,
										OPEN_EXISTING, 0, 0);
	if (serial_port==4)
	hComm = CreateFile("COM4", GENERIC_READ | GENERIC_WRITE, 0, 0,
										OPEN_EXISTING, 0, 0);
	if(hComm == INVALID_HANDLE_VALUE)
                AppQuit();     				//quit on port failure-insert your own routine
  									// SET THE COMM TIMEOUTS.
	GetCommTimeouts(hComm,&ctmoOld);
	ctmoNew.ReadTotalTimeoutConstant = 100;
	ctmoNew.ReadTotalTimeoutMultiplier = 0;
	ctmoNew.WriteTotalTimeoutMultiplier = 0;
	ctmoNew.WriteTotalTimeoutConstant = 0;
	SetCommTimeouts(hComm, &ctmoNew);

  // SET BAUD RATE, PARITY, WORD SIZE, AND STOP BITS.
  // THERE ARE OTHER WAYS OF DOING SETTING THESE BUT THIS IS THE EASIEST.
  // IF YOU WANT TO LATER ADD CODE FOR OTHER BAUD RATES, REMEMBER
  // THAT THE ARGUMENT FOR BuildCommDCB MUST BE A POINTER TO A STRING.
  // ALSO NOTE THAT BuildCommDCB() DEFAULTS TO NO HANDSHAKING.

	dcbCommPort.DCBlength = sizeof(DCB);
	GetCommState(hComm, &dcbCommPort);
	BuildCommDCB("9600,N,8,1", &dcbCommPort);
	SetCommState(hComm, &dcbCommPort);

}

void closecomporta(void)
{
	if(hComm)
	{
		printf("Closing...\n");
		SetCommTimeouts(hComm, &ctmoOld);     //restore old settings
		CloseHandle(hComm);
	}
}


void MainGameLoop(void)
{//The Main game Loop
int GameCycle;
//Check Timer
CurrentTimer = GetTickCount();
GameCycle = CurrentTimer - LastGameCycle;
//CheckGameCycle Timer. Increase this number to slow the game loop down.
if(GameCycle >400)
	{
	//code here
	getdistance();
	sprintf(wintext,"Speed: %03f  ",speed);
	sprintf(wintextb,"Dist: %04f  ",actualdistance);
	speeddec=speed;
	graph_ypos=600-(speeddec*20);
	TextOut(hdc,10,10,wintext,12);
	TextOut(hdc,10,30,wintextb,12);
	LineTo(hdc,graph_xpos,graph_ypos);
	getpace();
	if(graph_xpos>800)
		{
		LineTo(hdc,800,600);
		LineTo(hdc,0,600);
		graph_xpos=0;
		GetClientRect(hwnd, &rcClient);
		FillRect(hdc, &rcClient, GetStockObject(LTGRAY_BRUSH));
		}
	LastGameCycle = GetTickCount();
	}
}


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
    LPSTR lpCmdLine, int nCmdShow)
{
    WNDCLASSEX wc;
	printf(text);
	//MessageBox(hwnd,text,"Instructions",MB_ICONINFORMATION);
	printf( "\nAlso thanks to... \n");
	printf( "\tConcept2 for some example code\n");
	printf( "\tSyste - http://pm2erglib.sourceforge.net\n");
	//Select serial port
	printf( "\nSelect a serial port:\n" );
	printf( "1) COM 1\n" );
	printf( "2) COM 2\n" );
	printf( "3) COM 3\n" );
	printf( "4) COM 4\n" );
	scanf( "%d", &serial_port );
	printf( "Serial port %d selected.\n", serial_port );
	//serial_port--;  //so it's 0-3 instead of 1-4 for _bios_serialcom
	// above line not needed since were now using windows stuff not bios.
	rower = 0x00; //fixed
	metres = 0xb0; //ditto
	pace = 0xb1; //double ditto
	printf( "original command: %d\n",rower);
	printf( "original command: %d\n",metres);
	opencomporta();

    //MSG Msg;
    //Step 1: Registering the Window Class
    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         = 0;
    wc.lpfnWndProc   = WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInstance;
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = g_szClassName;
    wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);

    if(!RegisterClassEx(&wc))
    {
        MessageBox(NULL, "Window Registration Failed!", "Error!",
            MB_ICONEXCLAMATION | MB_OK);
        return 0;
    }

    // Step 2: Creating the Window
    hwnd = CreateWindowEx(
        WS_EX_CLIENTEDGE,
        g_szClassName,
        "PM2FC-w32 v2.0",
        WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT, CW_USEDEFAULT, 800, 600,
        NULL, NULL, hInstance, NULL);

    if(hwnd == NULL)
    {
        MessageBox(NULL, "Window Creation Failed!", "Error!",
            MB_ICONEXCLAMATION | MB_OK);
        return 0;
    }

    ShowWindow(hwnd, nCmdShow);
    UpdateWindow(hwnd);


	//Step 3: The Message Loop
    while(1)
    {
			if(PeekMessage(&Msg,NULL,0,0,PM_NOREMOVE))
				{
				if(!GetMessage(&Msg,NULL,0,0)) return Msg.wParam;
				TranslateMessage(&Msg);
				DispatchMessage(&Msg);
				}
			else
				{
				if(Active) MainGameLoop();
				else WaitMessage();
				}
    }
	return 0;
}
